using System;
using Server;
using Server.Network;
using Server.Prompts;
using Server.Items;
using Server.Mobiles;

namespace Server.Items
{
	public class LandDecorDeed : Item
	{	
		////////////////////////////////////////////////////////////////////////////////////////////////////	
		//Custom Menu Start EXAMPLE/////////////////////////////////////////////////////////////////////////
		////////////////////////////////////////////////////////////////////////////////////////////////////
		//	The following is a example of setting the deed to cover all land tiles named grass	  //
		//	with static item 3378 nand 3379	within X0-7000 and Y0-4900				  //
		////////////////////////////////////////////////////////////////////////////////////////////////////
		//This sets the land tile type that will be covered with random decor///////////////////////////////
		////////////////////////////////////////////////////////////////////////////////////////////////////
		//public string terrain = "grass"; 	//Uses : grass,dirt,snow,forest,cave,water,rocks etc etc..//
		////////////////////////////////////////////////////////////////////////////////////////////////////
		//public int LDID = 0;			//Uses: Item ID # of land tile to place random decor      //
		////////////////////////////////////////////////////////////////////////////////////////////////////
		//These are the random tile ID's for the items that will be added to the land tile//////////////////
		////////////////////////////////////////////////////////////////////////////////////////////////////
		//public int LD1 = 3378; 		//Use ItemID////////////////////////////////////////////////
		//public int LD2 = 3379;		//Use ItemID////////////////////////////////////////////////
		//public int LD3 = 0;			//Use ItemID////////////////////////////////////////////////
		//public int LD4 = 0;			//Use ItemID////////////////////////////////////////////////
		//public int LD5 = 0;			//Use ItemID////////////////////////////////////////////////
		//public int LD6 = 0;			//Use ItemID////////////////////////////////////////////////
		//public int LD7 = 0;			//Use ItemID////////////////////////////////////////////////
		//public int LD8 = 0;			//Use ItemID////////////////////////////////////////////////
		//public int LD9 = 0;			//Use ItemID////////////////////////////////////////////////
		//public int LD10 = 0;			//Use ItemID////////////////////////////////////////////////
		////////////////////////////////////////////////////////////////////////////////////////////////////
		////////////////////////////////////////////////////////////////////////////////////////////////////
		//public int BBX1 = 0;			//Use Starting X Point//////////////////////////////////////
		//public int BBX2 = 7000;		//Use Ending X Point////////////////////////////////////////
		//public int BBY1 = 0;			//Use Starting Y Point//////////////////////////////////////
		//public int BBY2 = 4900;		//Use Ending Y Point////////////////////////////////////////
		////////////////////////////////////////////////////////////////////////////////////////////////////
		//Custom Menu End EXAMPLE///////////////////////////////////////////////////////////////////////////
		////////////////////////////////////////////////////////////////////////////////////////////////////

		//Custom Menu Start

		public string terrain = ""; 
		public int LDID = 0;
		public int LD1 = 0; 
		public int LD2 = 0;
		public int LD3 = 0;
		public int LD4 = 0;
		public int LD5 = 0;
		public int LD6 = 0;
		public int LD7 = 0;
		public int LD8 = 0;
		public int LD9 = 0;
		public int LD10 = 0;
		public int BBX1 = 0;
		public int BBX2 = 0;
		public int BBY1 = 0;
		public int BBY2 = 0;

		//Custom Menu End

		///////////////////////////////////////////////////////////
		//MAKE SURE YOU HAVE YOUR MENU FILLED IN WITH YOUR VALUES//
		///////////////////////////////////////////////////////////

		public int LandDecorCount;
		public bool LandDecorStarted;

		public override string DefaultName
		{
			get { return "a land decor deed"; }
		}

		[Constructable]
		public LandDecorDeed() : base( 0x14F0 )
		{
			base.Weight = 1.0;
			Hue = 66;
			LandDecorCount = 0;
			LandDecorStarted = false;
		}

		public LandDecorDeed( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}

		public override void OnDoubleClick( Mobile from )
		{
			Mobile pm = from as Mobile;

			if ( pm == null )
				return;

			bool LDFail = false;
			bool Filled = false;
			
			if ( terrain != "" )
				Filled = true;
			if ( LDID != 0 )
				Filled = true;

			if ( LandDecorStarted == true )
			{
				pm.SendMessage("The System is Already Activated!");
				LDFail = true;
			}

			if ( Filled == false )
			{
				pm.SendMessage("You need to input a terrain type into the script!");
				LDFail = true;
			}
			
			if ( LD1 == 0 )
			{
				pm.SendMessage("You need to input at least one static ID in the script!");
				LDFail = true;
			}

			if ( BBX1 > BBX2 || BBY1 > BBY2 || BBX2 == 0 || BBY2 == 0 )
			{
				pm.SendMessage("You need to setup the bounding box properly, check your BBX & BBY Values!");
				LDFail = true;
			}
			
			if ( LDFail == true )
				return;

			LandDecorStarted = true;
			
			pm.SendMessage( "Land Decorating Started" );			

			//delay timer here?

			RunLong( pm );
		}

		public void RunLong( Mobile from )
		{
			Mobile pm = from as Mobile;

			if ( pm == null )
				return;

			for (int i = BBX1; i < BBX2; ++i)
                		RunWide( pm, i );

			pm.SendMessage( LandDecorCount + " Land Decoration Added" );

			Delete();
		}

		public void RunWide( Mobile from, int i )
		{
			Mobile pm = from as Mobile;

			if ( pm == null )
				return;

			int x = i;

			for (int j = BBY1; j < BBY2; ++j)
                		AddLandDecor( pm, x, j );
		}
		
		public void AddLandDecor( Mobile from, int x, int y )
		{
			Mobile pm = from as Mobile;

			if ( pm == null )
				return;

			int xx = x;
			int yy = y;

			StaticTile[] tiles = pm.Map.Tiles.GetStaticTiles( ( xx ), ( yy ), true );

			LandTile landTile = pm.Map.Tiles.GetLandTile( xx, yy );

			LandData lD = TileData.LandTable[ landTile.ID & 0x3FFF ];

			bool BadTile = false;
			bool Match = false;

			for ( int i = 0; i < tiles.Length; ++i )
					BadTile = true;
				
			if ( lD.Name == terrain )
				Match = true;

			if ( landTile.ID == LDID )
				Match = true;

			if ( Match == true && BadTile == false )
				switch (Utility.Random(4))
                		{
					case 0: RandomLandDecor( pm, xx, yy, landTile.Z ); break;
					case 1: RandomLandDecor( pm, xx, yy, landTile.Z ); break;
					case 2: RandomLandDecor( pm, xx, yy, landTile.Z ); break;
                    			case 3: break;
                		}
		}
		
		public void RandomLandDecor( Mobile from, int x, int y, int z )
		{
			Mobile pm = from as Mobile;

			if ( pm == null )
				return;

			Map map = pm.Map;

			if ( map == null )
				return;

			int d = 0;

			int xx = x;
			int yy = y;
			int zz = z;

                	switch (Utility.Random(50))
                	{
                    		case 0: d = LD1; break;
                    		case 1: d = LD2; break;
                    		case 2: d = LD3; break;
                    		case 3: d = LD4; break;
                    		case 4: d = LD5; break;
                    		case 5: d = LD6; break;
                    		case 6: d = LD7; break;
                    		case 7: d = LD8; break;
                    		case 8: d = LD9; break;
                    		case 9: d = LD10; break;
                	}

			if ( d == 0 )
				d = LD1;

			Static decor = new Static( d );
			
			Point3D loc = decor.Location;

			loc = new Point3D( xx, yy, zz );
			
			decor.MoveToWorld( loc, map );

			LandDecorCount++;
		}
	}
}


